//{{{
#include <cstdio>
#include <cctype>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <list>
#include <map>
#include <set>
#include <queue>
#include <cstring>
using namespace std;

#define FOR(I,A,B) for(int I=(A);I<(B);I++)
#define FORD(I,A,B) for(int I=(A);I>=(B);I--)
#define REP(I,N) for(int I=0;I<(N);I++)
#define VAR(V,init) __typeof(init) V=(init)
#define FOREACH(I,C) for(VAR(I,(C).begin());I!=(C).end();I++)
#define CLR(A,v) memset((A),v,sizeof((A)))


#define ALL(X) (X).begin(), (X).end()

#define PB push_back

#define MP make_pair
#define FI first
#define SE second

//}}}
const int nmx=100001;
vector<int> V[nmx];
int N[nmx],n;
const int mxg=1020;
const int sgg=317;
int TP[nmx],B[mxg],L[mxg],R[mxg];
bool TR[mxg];
int gr;
vector <int> GR;
map <int, int> MG;

// cut {{{
inline void cut(int g,int x,int &ga,int &gb)
{
	int la,lb,ra,rb;
	int px=TP[x]-L[g];
	MG.erase(R[g]);
	if (! TR[g] ) 
	{
		la=L[g];
		ra=L[g]+px-1;
		lb=L[g]+px+1;
		rb=R[g];
	}
	else
	{
		la=L[g]+px+1;
		ra=R[g];
		lb=L[g];
		rb=L[g]+px-1;
	}
	if (la <= ra)
	{	
		ga=gr++;
		L[ga]=la;
		R[ga]=ra;
		MG.insert( MP(ra,ga) );
		TR[ga]=TR[g];
	}
	else ga=-1;
	if (lb <= rb)
	{	
		gb=gr++;
		L[gb]=lb;
		R[gb]=rb;
		MG.insert( MP(rb,gb) );
		TR[gb]=TR[g];
	}
	else gb=-1;

}
// }}}

void newgroup(int x,int grupa)
{
	static vector<int> tmp;
	tmp.clear();
	int ga,gb;
	int l=GR.size();
	REP(i,l)
	{
		if (GR[i]== grupa)
		{
			cut(grupa,x,ga,gb);
			if (ga!=-1)
				tmp.PB(ga);
			reverse(ALL(tmp));
			FOREACH(i,tmp) TR[*i]=!(TR[*i]);
			if (gb!=-1)
				tmp.PB(gb);
		}
		else
			tmp.PB(GR[i]);
	}
	GR=tmp;
	l=GR.size();
//	printf("NW :%d\n",l);
	int suma=x+1;
	REP(i,l)
	{
		B[ GR[i] ]=suma;
		suma+=R[GR[i]]-L[GR[i]]+1;
	}
}

void popraw(int x)
{
	static int TB[nmx];
	int fr=x+1;
//	printf("START FR:%d x:%d\n",fr,x);
	int g;
	FOREACH(ggr,GR)
	{
		g=*ggr;
		if (!TR[g])
		{
			FOR(x,L[g],R[g]+1)
			{
//				printf("x%d fr:%d ",x,fr);
				TB[fr++]=N[x];
			}
		}
		else
		{
			FORD(x,R[g],L[g])
				TB[fr++]=N[x];
		}
	}
	REP(i,n)
	{
		N[i]=TB[i];
		TP[N[i]]=i;
	}
		L[0]=x+1;
		R[0]=n-1;
		gr=0;
		CLR(TR,0);
		GR.clear();
		GR.PB(0);
		MG.clear();
		MG.insert(MP(n-1,0));

}




int main() 
{
	int a;
	for(;;)
	{
		scanf("%d",&n);
	// wczyt {{{
		if (n==0) break;
		REP(i,nmx) V[i].clear();
		REP(i,n)
		{
			scanf("%d",&a);
			--a;
			V[a].PB(i);
		}
		int x=0;
		REP(i,nmx)
		 FOREACH(j,V[i])	N[  *j  ]=x++;
		REP(i,n)
			TP[N[i]]=i;
	// }}}
		CLR(TR,0);
		GR.clear();
		GR.PB(0);
		MG.clear();
		MG.insert(MP(n-1,0));
		B[0]=0;
		L[0]=0;
		R[0]=n-1;
		int thgr;
		REP(p,n)
		{
			thgr= (MG.lower_bound(TP[p])) -> SE;
		//	printf("i:%d thgr:%d TP:%d b:%d l:%d r:%d \n",p,thgr,TP[p],B[thgr],L[thgr],R[thgr]);
			printf("%d ",1+B[thgr] + (TR[thgr]? (R[thgr]-TP[p]) : (TP[p]-L[thgr])));
			newgroup(p,thgr);
			if ((int)GR.size()>= sgg)
				popraw(p);
//		printf("p:%d SU :%d\n",p,su);

		}
		printf("\n");

	}	
	return 0;
}
